"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .decimalcreate import DecimalCreate, DecimalCreateTypedDict
from .retirementcontributioncreate import (
    RetirementContributionCreate,
    RetirementContributionCreateTypedDict,
)
from ascend_sdk.types import BaseModel
from typing import Optional
from typing_extensions import NotRequired, TypedDict


class AchDepositCreateTypedDict(TypedDict):
    r"""A deposit transfer using the ACH mechanism."""

    amount: DecimalCreateTypedDict
    r"""A representation of a decimal value, such as 2.5. Clients may convert values into language-native decimal formats, such as Java's [BigDecimal][] or Python's [decimal.Decimal][].

    [BigDecimal]:
    https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/math/BigDecimal.html
    [decimal.Decimal]: https://docs.python.org/3/library/decimal.html
    """
    bank_relationship: str
    r"""The bank relationship to be used for the ACH deposit."""
    client_transfer_id: str
    r"""The external identifier supplied by the API caller. Each request must have a unique pairing of `client_transfer_id` and `account`."""
    memo: NotRequired[str]
    r"""The memo that will appear on the customer's bank statement."""
    retirement_contribution: NotRequired[RetirementContributionCreateTypedDict]
    r"""A contribution to a retirement account."""


class AchDepositCreate(BaseModel):
    r"""A deposit transfer using the ACH mechanism."""

    amount: DecimalCreate
    r"""A representation of a decimal value, such as 2.5. Clients may convert values into language-native decimal formats, such as Java's [BigDecimal][] or Python's [decimal.Decimal][].

    [BigDecimal]:
    https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/math/BigDecimal.html
    [decimal.Decimal]: https://docs.python.org/3/library/decimal.html
    """

    bank_relationship: str
    r"""The bank relationship to be used for the ACH deposit."""

    client_transfer_id: str
    r"""The external identifier supplied by the API caller. Each request must have a unique pairing of `client_transfer_id` and `account`."""

    memo: Optional[str] = None
    r"""The memo that will appear on the customer's bank statement."""

    retirement_contribution: Optional[RetirementContributionCreate] = None
    r"""A contribution to a retirement account."""
