"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from ascend_sdk import utils
from ascend_sdk.types import BaseModel
from ascend_sdk.utils import validate_open_enum
from enum import Enum
from pydantic.functional_validators import PlainValidator
from typing import Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class CheckPartyTypeResponsePartyType(str, Enum, metaclass=utils.OpenEnumMeta):
    r"""Whether the cash journal is considered first party or third party"""

    PARTY_TYPE_UNSPECIFIED = "PARTY_TYPE_UNSPECIFIED"
    FIRST_PARTY = "FIRST_PARTY"
    THIRD_PARTY = "THIRD_PARTY"


class CheckPartyTypeResponseTypedDict(TypedDict):
    r"""Returns whether a potential cash journal will be considered first party or third party"""

    party_type: NotRequired[CheckPartyTypeResponsePartyType]
    r"""Whether the cash journal is considered first party or third party"""
    reason: NotRequired[str]
    r"""If cash journal is considered third party, reason for why it is considered third party"""


class CheckPartyTypeResponse(BaseModel):
    r"""Returns whether a potential cash journal will be considered first party or third party"""

    party_type: Annotated[
        Optional[CheckPartyTypeResponsePartyType],
        PlainValidator(validate_open_enum(False)),
    ] = None
    r"""Whether the cash journal is considered first party or third party"""

    reason: Optional[str] = None
    r"""If cash journal is considered third party, reason for why it is considered third party"""
