"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .eddaccountenrollmentmetadatacreate import (
    EddAccountEnrollmentMetadataCreate,
    EddAccountEnrollmentMetadataCreateTypedDict,
)
from ascend_sdk import utils
from ascend_sdk.types import BaseModel
from ascend_sdk.utils import validate_open_enum
from enum import Enum
from pydantic.functional_validators import PlainValidator
from typing import Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class DividendReinvestmentPlan(str, Enum, metaclass=utils.OpenEnumMeta):
    r"""Option to auto-enroll in Dividend Reinvestment; defaults to true"""

    AUTO_ENROLL_DIVIDEND_REINVESTMENT_UNSPECIFIED = (
        "AUTO_ENROLL_DIVIDEND_REINVESTMENT_UNSPECIFIED"
    )
    DIVIDEND_REINVESTMENT_ENROLL = "DIVIDEND_REINVESTMENT_ENROLL"
    DIVIDEND_REINVESTMENT_DECLINE = "DIVIDEND_REINVESTMENT_DECLINE"


class FdicCashSweep(str, Enum, metaclass=utils.OpenEnumMeta):
    r"""Option to auto-enroll in FDIC cash sweep; defaults to true"""

    AUTO_ENROLL_FDIC_CASH_SWEEP_UNSPECIFIED = "AUTO_ENROLL_FDIC_CASH_SWEEP_UNSPECIFIED"
    FDIC_CASH_SWEEP_ENROLL = "FDIC_CASH_SWEEP_ENROLL"
    FDIC_CASH_SWEEP_DECLINE = "FDIC_CASH_SWEEP_DECLINE"


class CorporationEnrollmentMetadataCreateTypedDict(TypedDict):
    dividend_reinvestment_plan: NotRequired[DividendReinvestmentPlan]
    r"""Option to auto-enroll in Dividend Reinvestment; defaults to true"""
    edd_account_enrollment_metadata: NotRequired[
        EddAccountEnrollmentMetadataCreateTypedDict
    ]
    r"""Enrollment metadata for Entity Accounts"""
    fdic_cash_sweep: NotRequired[FdicCashSweep]
    r"""Option to auto-enroll in FDIC cash sweep; defaults to true"""


class CorporationEnrollmentMetadataCreate(BaseModel):
    dividend_reinvestment_plan: Annotated[
        Optional[DividendReinvestmentPlan], PlainValidator(validate_open_enum(False))
    ] = None
    r"""Option to auto-enroll in Dividend Reinvestment; defaults to true"""

    edd_account_enrollment_metadata: Optional[EddAccountEnrollmentMetadataCreate] = None
    r"""Enrollment metadata for Entity Accounts"""

    fdic_cash_sweep: Annotated[
        Optional[FdicCashSweep], PlainValidator(validate_open_enum(False))
    ] = None
    r"""Option to auto-enroll in FDIC cash sweep; defaults to true"""
