"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .decimalcreate import DecimalCreate, DecimalCreateTypedDict
from ascend_sdk.types import BaseModel
from typing_extensions import TypedDict


class DepositedFundsCreateTypedDict(TypedDict):
    r"""The initial amount of money placed into the account by the entity upon or after the account's establishment."""

    initial_deposit_amount: DecimalCreateTypedDict
    r"""A representation of a decimal value, such as 2.5. Clients may convert values into language-native decimal formats, such as Java's [BigDecimal][] or Python's [decimal.Decimal][].

    [BigDecimal]:
    https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/math/BigDecimal.html
    [decimal.Decimal]: https://docs.python.org/3/library/decimal.html
    """
    initial_deposit_source: str
    r"""The source of the initial deposit"""


class DepositedFundsCreate(BaseModel):
    r"""The initial amount of money placed into the account by the entity upon or after the account's establishment."""

    initial_deposit_amount: DecimalCreate
    r"""A representation of a decimal value, such as 2.5. Clients may convert values into language-native decimal formats, such as Java's [BigDecimal][] or Python's [decimal.Decimal][].

    [BigDecimal]:
    https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/math/BigDecimal.html
    [decimal.Decimal]: https://docs.python.org/3/library/decimal.html
    """

    initial_deposit_source: str
    r"""The source of the initial deposit"""
