"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .decimalcreate import DecimalCreate, DecimalCreateTypedDict
from ascend_sdk import utils
from ascend_sdk.types import BaseModel
from ascend_sdk.utils import validate_open_enum
from enum import Enum
from pydantic.functional_validators import PlainValidator
from typing_extensions import Annotated, TypedDict


class FeeCreateType(str, Enum, metaclass=utils.OpenEnumMeta):
    r"""The type of fee being specified. Only the type of \"BROKER_FEE\" is supported."""

    FEE_TYPE_UNSPECIFIED = "FEE_TYPE_UNSPECIFIED"
    BROKER_FEE = "BROKER_FEE"


class FeeCreateTypedDict(TypedDict):
    r"""A fee that applies to an order"""

    amount: DecimalCreateTypedDict
    r"""A representation of a decimal value, such as 2.5. Clients may convert values into language-native decimal formats, such as Java's [BigDecimal][] or Python's [decimal.Decimal][].

    [BigDecimal]:
    https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/math/BigDecimal.html
    [decimal.Decimal]: https://docs.python.org/3/library/decimal.html
    """
    type: FeeCreateType
    r"""The type of fee being specified. Only the type of \"BROKER_FEE\" is supported."""


class FeeCreate(BaseModel):
    r"""A fee that applies to an order"""

    amount: DecimalCreate
    r"""A representation of a decimal value, such as 2.5. Clients may convert values into language-native decimal formats, such as Java's [BigDecimal][] or Python's [decimal.Decimal][].

    [BigDecimal]:
    https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/math/BigDecimal.html
    [decimal.Decimal]: https://docs.python.org/3/library/decimal.html
    """

    type: Annotated[FeeCreateType, PlainValidator(validate_open_enum(False))]
    r"""The type of fee being specified. Only the type of \"BROKER_FEE\" is supported."""
