"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .watchlistmatchupdate import WatchlistMatchUpdate, WatchlistMatchUpdateTypedDict
from ascend_sdk import utils
from ascend_sdk.types import BaseModel
from ascend_sdk.utils import validate_open_enum
from enum import Enum
from pydantic.functional_validators import PlainValidator
from typing import List, Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class InvestigationUpdateIdentityVerification(str, Enum, metaclass=utils.OpenEnumMeta):
    r"""Indicates the current state of identity verification"""

    SCREEN_STATE_UNSPECIFIED = "SCREEN_STATE_UNSPECIFIED"
    PENDING = "PENDING"
    PASSED = "PASSED"
    FAILED = "FAILED"
    NEEDS_REVIEW = "NEEDS_REVIEW"
    DEFERRED_REVIEW = "DEFERRED_REVIEW"
    OUT_OF_SCOPE = "OUT_OF_SCOPE"


class InvestigationUpdateInvestigationRequestState(
    str, Enum, metaclass=utils.OpenEnumMeta
):
    r"""Current state of investigation request"""

    INVESTIGATION_REQUEST_STATE_UNSPECIFIED = "INVESTIGATION_REQUEST_STATE_UNSPECIFIED"
    OPEN = "OPEN"
    CLOSED = "CLOSED"


class InvestigationUpdateTypedDict(TypedDict):
    r"""Contains investigation details of corresponding investigation"""

    comment: NotRequired[str]
    r"""Comment relating to why the investigation state was updated"""
    identity_verification: NotRequired[InvestigationUpdateIdentityVerification]
    r"""Indicates the current state of identity verification"""
    investigation_request_state: NotRequired[
        InvestigationUpdateInvestigationRequestState
    ]
    r"""Current state of investigation request"""
    watchlist_matches: NotRequired[List[WatchlistMatchUpdateTypedDict]]
    r"""A list of watchlist entries matched against the investigation"""


class InvestigationUpdate(BaseModel):
    r"""Contains investigation details of corresponding investigation"""

    comment: Optional[str] = None
    r"""Comment relating to why the investigation state was updated"""

    identity_verification: Annotated[
        Optional[InvestigationUpdateIdentityVerification],
        PlainValidator(validate_open_enum(False)),
    ] = None
    r"""Indicates the current state of identity verification"""

    investigation_request_state: Annotated[
        Optional[InvestigationUpdateInvestigationRequestState],
        PlainValidator(validate_open_enum(False)),
    ] = None
    r"""Current state of investigation request"""

    watchlist_matches: Optional[List[WatchlistMatchUpdate]] = None
    r"""A list of watchlist entries matched against the investigation"""
