"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from ascend_sdk import utils
from ascend_sdk.types import (
    BaseModel,
    Nullable,
    OptionalNullable,
    UNSET,
    UNSET_SENTINEL,
)
from ascend_sdk.utils import validate_open_enum
from enum import Enum
from pydantic import model_serializer
from pydantic.functional_validators import PlainValidator
from typing import Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class MarkPricePriceTypedDict(TypedDict):
    r"""The price value"""

    value: NotRequired[str]
    r"""The decimal value, as a string; Refer to [Google’s Decimal type protocol buffer](https://github.com/googleapis/googleapis/blob/40203ca1880849480bbff7b8715491060bbccdf1/google/type/decimal.proto#L33) for details"""


class MarkPricePrice(BaseModel):
    r"""The price value"""

    value: Optional[str] = None
    r"""The decimal value, as a string; Refer to [Google’s Decimal type protocol buffer](https://github.com/googleapis/googleapis/blob/40203ca1880849480bbff7b8715491060bbccdf1/google/type/decimal.proto#L33) for details"""


class MarkPriceType(str, Enum, metaclass=utils.OpenEnumMeta):
    r"""The calculation type of this price"""

    PERCENTAGE_OF_PAR = "PERCENTAGE_OF_PAR"
    DIRTY_PERCENTAGE_OF_PAR = "DIRTY_PERCENTAGE_OF_PAR"
    YIELD_TO_WORST = "YIELD_TO_WORST"
    YIELD_TO_MATURITY = "YIELD_TO_MATURITY"


class MarkPriceTypedDict(TypedDict):
    r"""The definition of a price value and its calculation method as returned in mark data"""

    price: NotRequired[Nullable[MarkPricePriceTypedDict]]
    r"""The price value"""
    type: NotRequired[MarkPriceType]
    r"""The calculation type of this price"""


class MarkPrice(BaseModel):
    r"""The definition of a price value and its calculation method as returned in mark data"""

    price: OptionalNullable[MarkPricePrice] = UNSET
    r"""The price value"""

    type: Annotated[
        Optional[MarkPriceType], PlainValidator(validate_open_enum(False))
    ] = None
    r"""The calculation type of this price"""

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = ["price", "type"]
        nullable_fields = ["price"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in self.model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m
