"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from ascend_sdk.types import (
    BaseModel,
    Nullable,
    OptionalNullable,
    UNSET,
    UNSET_SENTINEL,
)
from pydantic import model_serializer
from typing import Optional
from typing_extensions import NotRequired, TypedDict


class Amount1TypedDict(TypedDict):
    r"""The amount of one of the micro deposits."""

    value: NotRequired[str]
    r"""The decimal value, as a string; Refer to [Google’s Decimal type protocol buffer](https://github.com/googleapis/googleapis/blob/40203ca1880849480bbff7b8715491060bbccdf1/google/type/decimal.proto#L33) for details"""


class Amount1(BaseModel):
    r"""The amount of one of the micro deposits."""

    value: Optional[str] = None
    r"""The decimal value, as a string; Refer to [Google’s Decimal type protocol buffer](https://github.com/googleapis/googleapis/blob/40203ca1880849480bbff7b8715491060bbccdf1/google/type/decimal.proto#L33) for details"""


class Amount2TypedDict(TypedDict):
    r"""The amount of the other micro deposit."""

    value: NotRequired[str]
    r"""The decimal value, as a string; Refer to [Google’s Decimal type protocol buffer](https://github.com/googleapis/googleapis/blob/40203ca1880849480bbff7b8715491060bbccdf1/google/type/decimal.proto#L33) for details"""


class Amount2(BaseModel):
    r"""The amount of the other micro deposit."""

    value: Optional[str] = None
    r"""The decimal value, as a string; Refer to [Google’s Decimal type protocol buffer](https://github.com/googleapis/googleapis/blob/40203ca1880849480bbff7b8715491060bbccdf1/google/type/decimal.proto#L33) for details"""


class MicroDepositAmountsTypedDict(TypedDict):
    r"""The micro deposits sent to verify a pending bank relationship. FOR TESTING ONLY!"""

    amount1: NotRequired[Nullable[Amount1TypedDict]]
    r"""The amount of one of the micro deposits."""
    amount2: NotRequired[Nullable[Amount2TypedDict]]
    r"""The amount of the other micro deposit."""


class MicroDepositAmounts(BaseModel):
    r"""The micro deposits sent to verify a pending bank relationship. FOR TESTING ONLY!"""

    amount1: OptionalNullable[Amount1] = UNSET
    r"""The amount of one of the micro deposits."""

    amount2: OptionalNullable[Amount2] = UNSET
    r"""The amount of the other micro deposit."""

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = ["amount1", "amount2"]
        nullable_fields = ["amount1", "amount2"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in self.model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m
