"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from ascend_sdk import utils
from ascend_sdk.types import BaseModel
from ascend_sdk.utils import validate_open_enum
from enum import Enum
from pydantic.functional_validators import PlainValidator
from typing_extensions import Annotated, TypedDict


class RetrieveDistributionConstraintsRequestCreateMechanism(
    str, Enum, metaclass=utils.OpenEnumMeta
):
    r"""Cash transfer mechanism to search constraints for"""

    ACH = "ACH"
    ICT = "ICT"


class RetrieveDistributionConstraintsRequestCreateTypedDict(TypedDict):
    r"""Request to retrieve retirement distribution constraints"""

    mechanism: RetrieveDistributionConstraintsRequestCreateMechanism
    r"""Cash transfer mechanism to search constraints for"""
    name: str
    r"""Name of the account being queried, for retirement distribution constraints Format: accounts/{account}"""


class RetrieveDistributionConstraintsRequestCreate(BaseModel):
    r"""Request to retrieve retirement distribution constraints"""

    mechanism: Annotated[
        RetrieveDistributionConstraintsRequestCreateMechanism,
        PlainValidator(validate_open_enum(False)),
    ]
    r"""Cash transfer mechanism to search constraints for"""

    name: str
    r"""Name of the account being queried, for retirement distribution constraints Format: accounts/{account}"""
