"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from ascend_sdk.models.components import (
    account as components_account,
    httpmetadata as components_httpmetadata,
    status as components_status,
)
from ascend_sdk.types import BaseModel
from ascend_sdk.utils import FieldMetadata, PathParamMetadata, QueryParamMetadata
from enum import Enum
import pydantic
from typing import Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class QueryParamView(str, Enum):
    r"""The view to return. Defaults to `FULL`."""

    ACCOUNT_VIEW_UNSPECIFIED = "ACCOUNT_VIEW_UNSPECIFIED"
    BASIC = "BASIC"
    FULL = "FULL"


class AccountsGetAccountRequestTypedDict(TypedDict):
    account_id: str
    r"""The account id."""
    view: NotRequired[QueryParamView]
    r"""The view to return. Defaults to `FULL`."""


class AccountsGetAccountRequest(BaseModel):
    account_id: Annotated[
        str, FieldMetadata(path=PathParamMetadata(style="simple", explode=False))
    ]
    r"""The account id."""

    view: Annotated[
        Optional[QueryParamView],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = None
    r"""The view to return. Defaults to `FULL`."""


class AccountsGetAccountResponseTypedDict(TypedDict):
    http_meta: components_httpmetadata.HTTPMetadataTypedDict
    account: NotRequired[components_account.AccountTypedDict]
    r"""OK"""
    status: NotRequired[components_status.StatusTypedDict]
    r"""INVALID_ARGUMENT: The request is not valid, additional information may be present in the BadRequest details."""


class AccountsGetAccountResponse(BaseModel):
    http_meta: Annotated[
        Optional[components_httpmetadata.HTTPMetadata], pydantic.Field(exclude=True)
    ] = None

    account: Optional[components_account.Account] = None
    r"""OK"""

    status: Optional[components_status.Status] = None
    r"""INVALID_ARGUMENT: The request is not valid, additional information may be present in the BadRequest details."""
